﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace prüfsummeCalculator
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }        
        private byte[] prufSumme = { 0, 0, 0, 0 };
        private void Form1_Load(object sender, EventArgs e)
        {
            cmbxChn.Items.Add((object)"A");
            cmbxChn.Items.Add((object)"B");
            cmbxChn.Items.Add((object)"C");
            cmbxChn.Items.Add((object)"LS");
            cmbxChn.SelectedItem = "A";
            for (int i = 1; i <= 8; i++)
            {
                cmbxNum.Items.Add((object)i);
            }
            cmbxNum.SelectedItem = 1;
            cmbxOnOff.Items.Add((object)"On");
            cmbxOnOff.Items.Add((object)"Off");
            cmbxOnOff.SelectedItem = "On";
            cmbxFirst.Items.Add((object)"First");
            cmbxFirst.Items.Add((object)"NOT First");
            cmbxFirst.SelectedItem =  "First";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //convert SN to bitstream;
            string str = tbSN.Text;
            char[] c = str.ToCharArray();
            List<char> lc = new List<char>();
            foreach (char ch in c)
            {
                lc.Add(ch);
            }
            lc.Reverse();
            c = null;
            c = lc.ToArray();
            str = new string(c);
            ushort s = Convert.ToUInt16(str, 2);
           
            //first bit
            byte X = 51; //0011 0011
            if((s&(1<<2))>0)
                X = (byte)~X;
            if ((string)cmbxOnOff.SelectedItem == "Off")
                X = (byte)~X;
            if ((string)cmbxChn.SelectedItem == "B" || (string)cmbxChn.SelectedItem == "LS")
                X = (byte)~X;
            prufSumme[0] = (byte)(X & (1 << ((int)cmbxNum.SelectedItem - 1)));

            //second bit
            byte Y = 255; //1111 1111
            if ((s & 1) > 0)
                Y = (byte)~Y;
            if ((string)cmbxOnOff.SelectedItem == "Off")
                Y = (byte)~Y;
            if ((string)cmbxChn.SelectedItem == "B" || (string)cmbxChn.SelectedItem == "LS")
                Y = (byte)~Y;
            prufSumme[1] = (byte)(Y & (1 << ((int)cmbxNum.SelectedItem - 1)));

            //third bit
            byte Z = 165; //10100101
            if ((s & 1<<1) == 0)
                Z = (byte)~Z;
            if ((string)cmbxOnOff.SelectedItem == "Off")
                Z = (byte)~Z;
            if ((string)cmbxFirst.SelectedItem == "NOT First")
                Z = (byte)~Z;
            if ((string)cmbxChn.SelectedItem == "C" || (string)cmbxChn.SelectedItem == "LS")
                Z = (byte)~Z;
            prufSumme[2] = (byte)(Z & (1 << ((int)cmbxNum.SelectedItem - 1)));

            //fourth bit
            byte J = 15; //0000 1111
            if ((s & 1 << 3) == 0)
                J = (byte)~J;
            if ((string)cmbxOnOff.SelectedItem == "Off")
                J = (byte)~J;           
            
            prufSumme[3] = (byte)(J & (1 << ((int)cmbxNum.SelectedItem - 1)));

            for (int i = 0; i < 4; i++)
            {
                if (prufSumme[i] > 0)
                    prufSumme[i] = 1;
            }

            tbPrüfsumme.Text = "" + prufSumme[0] + prufSumme[1] + prufSumme[2] + prufSumme[3] ;
        }

        private void cbTopMost_CheckedChanged(object sender, EventArgs e)
        {
            this.TopMost = cbTopMost.Checked;
        }

        private void cmbxSn_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch ((string)cmbxSn.SelectedItem)
            {
                case "Fernbedienung":
                    tbSN.Text = "0101100100001000";
                    break;
                case "Schalter 1":
                    tbSN.Text = "0110101111100100";
                    break;
                case "Schalter 2":
                    tbSN.Text = "0011110100000000";
                    break;
                default:
                    tbSN.Text = "";
                    break;
            }
        }

    }
}
